extends RigidBody2D

var state_machine
export(NodePath) var cat
var target
var threshold = 10
var can_bark = false
var cat_found = false

func _ready():
	target = get_node(cat)
	$dog/AnimationTree.active = true
	state_machine = $dog/AnimationTree["parameters/playback"]
	state_machine.start("idle")
	pass # Replace with function body.

func _process(delta):
	if linear_velocity.length() < 5:
		linear_velocity = Vector2()
	
	if target:
		$dog.scale.x = sign(target.position.x - position.x)
	
	if linear_velocity.y > threshold or linear_velocity.y < -threshold:
		if state_machine.get_current_node() != "jump":
			state_machine.start("jump")
			print("run")
	elif linear_velocity.x>0:
		if state_machine.get_current_node() != "run":
			state_machine.start("run")
			print("run")
	elif linear_velocity.length() > -threshold and linear_velocity.length() < threshold and can_bark:
		var space_state = get_world_2d().direct_space_state
		var result = space_state.intersect_ray(global_position, target.global_position, [self])
		if result:
			if result["collider"] == target:
				if state_machine.get_current_node() != "bark":
					state_machine.start("bark")
					cat_found = true
				print("bark")
	else:
		if state_machine.get_current_node() != "idle":
			state_machine.travel("idle")
			print("idle")
			
func initial_pulse():
	apply_central_impulse(Vector2(800, 0))
		
